package Data;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class AddingHyperlinksServlet extends HttpServlet  {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
   throws IOException, ServletException
{
  OutputStream out = response.getOutputStream();
  try
  {
      setResponseHeader(response, "AddingHyperlinks.xls");
      CreateAddingHyperlinks(out);
   }
  catch (Exception ex)
  {
      ex.printStackTrace();

      // say sorry
      response.setContentType("text/html");
      PrintWriter writer = new PrintWriter(out);

      writer.println("<html>");
      writer.println("<head>");
      writer.println("<title>sorry</title>");
      writer.println("</head>");
      writer.println("<body>");
      writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
      ex.printStackTrace(writer);
      writer.println("</body>");
      writer.println("</html>");
      writer.close();
  }
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
       throws IOException, ServletException
 {
    doGet(request, response);
 }

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
   response.setContentType("application/vnd.ms-excel");
   response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateAddingHyperlinks(OutputStream out) throws IOException
{
  Workbook workbook = new Workbook();

  CreateStaticReport(workbook);

  //Saving the Excel file
  workbook.save(out);
}

private void CreateStaticReport(Workbook workbook)
{
  Worksheets worksheets = workbook.getWorksheets();
  Worksheet worksheet = worksheets.getSheet(0);

  Cells cells = worksheet.getCells();
  Cell cell;
  /*  Adding link to a URL  */
  //Put a value into a cell
  cell = cells.getCell("A1");
  cell.setValue("Visit Aspose");
  Style style = cell.getStyle();
  Font font = new Font();
  font.setColor(Color.BLUE);
  font.setUnderline(Font.UNDERLINE_SINGLE);
  style.setFont(font);
  cell.setStyle(style);

  //Add a hyperlink to a URL at "A1" cell
  worksheet.getHyperlinks().add("A1", "B1", "http://www.aspose.com", "Hello Aspose", "1");

  /*Adding a link to an external file*/
  //Put a value into a cell
  cell = cells.getCell("A5");
  cell.setValue("SmartMarkerDesigner.xls");

  String FILE_PATH_PART = "/WEB-INF/Designer/SmartMarkerDesigner.xls";
  ServletContext sc = getServletContext();
  String template_file_path = sc.getRealPath(FILE_PATH_PART);

  //Add a hyperlink to a URL at "B2" cell
  worksheet.getHyperlinks().add(4, 0, 4, 1, template_file_path, "Excel File", "1");
}
}
