package Data;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class DataFilterServlet extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
     throws IOException, ServletException
  {
    OutputStream out = response.getOutputStream();
    try
    {
        setResponseHeader(response, "DataFilter.xls");
        CreateDataFilter(out);
     }
    catch (Exception ex)
    {
        ex.printStackTrace();

        // say sorry
        response.setContentType("text/html");
        PrintWriter writer = new PrintWriter(out);

        writer.println("<html>");
        writer.println("<head>");
        writer.println("<title>sorry</title>");
        writer.println("</head>");
        writer.println("<body>");
        writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
        ex.printStackTrace(writer);
        writer.println("</body>");
        writer.println("</html>");
        writer.close();
    }
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response)
         throws IOException, ServletException
   {
      doGet(request, response);
   }

  private void setResponseHeader(HttpServletResponse response, String resultXLS)
  {
     response.setContentType("application/vnd.ms-excel");
     response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
  }

  private void CreateDataFilter(OutputStream out) throws IOException
  {
    Workbook workbook = new Workbook();

    CreateStaticReport(workbook);

    //Saving the Excel file
    workbook.save(out);
  }

  private void CreateStaticReport(Workbook workbook)
  {
    Worksheets worksheets = workbook.getWorksheets();
    Worksheet worksheet = worksheets.getSheet(0);

    Cells cells = worksheet.getCells();
    Cell cell;
    //Put a value into a cell
    cell = cells.getCell("A1");
    cell.setValue("Fruit");
    cell = cells.getCell("B1");
    cell.setValue("Total");
    cell = cells.getCell("A2");
    cell.setValue("Apple");
    cell = cells.getCell("B2");
    cell.setValue(1000);
    cell = cells.getCell("A3");
    cell.setValue("Orange");
    cell = cells.getCell("B3");
    cell.setValue(2500);
    cell = cells.getCell("A4");
    cell.setValue("Bananas");
    cell = cells.getCell("B4");
    cell.setValue(2500);
    cell = cells.getCell("A5");
    cell.setValue("Pear");
    cell = cells.getCell("B5");
    cell.setValue(1000);
    cell = cells.getCell("A6");
    cell.setValue("Grape");
    cell = cells.getCell("B6");
    cell.setValue(2000);

    cell = cells.getCell("D1");
    cell.setValue("Count:");
    cell = cells.getCell("E1");
    cell.setFormula("=SUBTOTAL(2, B1:B6)");

    CellArea cellArea = new CellArea("A1", "B6");
    worksheet.getAutoFilter().setRange(cellArea);
  }
}
