package Data;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class DataValidationServlet extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
     throws IOException, ServletException
  {
    OutputStream out = response.getOutputStream();
    try
    {
        setResponseHeader(response, "DataValidation.xls");
        CreateDataValidation(out);
     }
    catch (Exception ex)
    {
        ex.printStackTrace();

        // say sorry
        response.setContentType("text/html");
        PrintWriter writer = new PrintWriter(out);

        writer.println("<html>");
        writer.println("<head>");
        writer.println("<title>sorry</title>");
        writer.println("</head>");
        writer.println("<body>");
        writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
        ex.printStackTrace(writer);
        writer.println("</body>");
        writer.println("</html>");
        writer.close();
    }
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response)
         throws IOException, ServletException
   {
      doGet(request, response);
   }

  private void setResponseHeader(HttpServletResponse response, String resultXLS)
  {
     response.setContentType("application/vnd.ms-excel");
     response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
  }

  private void CreateDataValidation(OutputStream out) throws IOException
  {
    Workbook workbook = new Workbook();
    Worksheets worksheets = workbook.getWorksheets();
    Worksheet worksheet = worksheets.getSheet(0);

    Cells cells = worksheet.getCells();
    Validations validations = worksheet.getValidations();

    //Data Validation for Numbers
    ValidationForNumbers(cells, validations);

    //Saving the Excel file
    workbook.save(out);
  }

  private void ValidationForNumbers(Cells cells, Validations validations)
  {
    Cell cell;
    cell = cells.getCell("A1");
    cell.setValue("Enter Number:");
    cell = cells.getCell("B1");
    cell.setValue(100);
    //Create a validation object
    int index = validations.add();
    Validation validation = validations.get(index);
    //Set the validation type to whole number
    validation.setType(ValidationType.WHOLE_NUMBER);
    //Set the operator for validation to between
    validation.setOperator(OperatorType.BETWEEN);
    //Set the minimum value for the validation
    validation.setFormula1("0");
    //Set the maximum value for the validation
    validation.setFormula2("10");
    validation.setShowError(true);
    validation.setAlertType(ValidationAlertType.INFORMATION);
    validation.setErrorTitle("Error");
    validation.setErrorMessage("Enter value between 0 to 10");
    validation.setInputMessage("Data Validation using Condition for Numbers");
    validation.setIgnoreBlank(true);
    validation.setShowInput(true);
    validation.setShowError(true);

    //Apply the validation to a range of cells from B1 to B1 using the CellArea structure
    CellArea cellArea = new CellArea();
    cellArea.setStartRow(0);
    cellArea.setEndRow(0);
    cellArea.setStartColumn(1);
    cellArea.setEndColumn(1);

    //Add the cell area to Validation
    validation.getAreaList().add(cellArea);
  }
}
