package Data;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class HelloWorldServlet extends HttpServlet {

  private static final String TEMPLATE_FILE_PATH_PART = "/WEB-INF/Designer/Workbooks/HelloWorld.xls";

  public void doGet(HttpServletRequest request, HttpServletResponse response)
     throws IOException, ServletException
  {
    OutputStream out = response.getOutputStream();
    try
    {
      ServletContext sc = getServletContext();
      String template_file_path = sc.getRealPath(TEMPLATE_FILE_PATH_PART);

        setResponseHeader(response, "HelloWorld.xls");
        CreateHelloWorld(out, template_file_path);
     }
    catch (Exception ex)
    {
        ex.printStackTrace();

        // say sorry
        response.setContentType("text/html");
        PrintWriter writer = new PrintWriter(out);

        writer.println("<html>");
        writer.println("<head>");
        writer.println("<title>sorry</title>");
        writer.println("</head>");
        writer.println("<body>");
        writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
        ex.printStackTrace(writer);
        writer.println("</body>");
        writer.println("</html>");
        writer.close();
    }
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response)
         throws IOException, ServletException
   {
      doGet(request, response);
   }

  private void setResponseHeader(HttpServletResponse response, String resultXLS)
  {
     response.setContentType("application/vnd.ms-excel");
     response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
  }

  private void CreateHelloWorld(OutputStream out, String template_file_path) throws IOException
  {
    Workbook workbook = new Workbook();

    workbook.open(template_file_path);

    CreateStaticReport(workbook);

    //Saving the Excel file
    workbook.save(out);
  }

  private void CreateStaticReport(Workbook workbook)
  {
    Worksheets worksheets = workbook.getWorksheets();
    Worksheet worksheet = worksheets.getSheet(0);
    Cells cells = worksheet.getCells();
    Cell cell;

    //Put a string value into the cell using its name
    cell = cells.getCell("A1");
    cell.setValue("Cell Value");

    //put a string value into the cell using its name
    cell = cells.getCell("A2");
    cell.setValue("Hello World");

    //Put an boolean value into the cell using its name
    cell = cells.getCell("A3");
    cell.setValue(true);

    //Put an int value into the cell using its name
    cell = cells.getCell("A4");
    cell.setValue(100);

    //Put an double value into the cell using its name
    cell = cells.getCell("A5");
    cell.setValue(2856.5);

    //Put an object value into the cell using its name
    Object obj = "Aspose";
    cell = cells.getCell("A6");
    cell.setValue(obj);

    //Put an datetime value into the cell
    Calendar calendar = Calendar.getInstance();
    cell = cells.getCell("A7");
    cell.setValue(calendar);
    Style style = cell.getStyle();
    style.setNumber(14);
    cell.setStyle(style);

    //Put a string value into the cell using its row and column
    cell = cells.getCell(0,1);
    cell.setValue("Cell Value Type");
    int temp ;
    for (int i = 1; i < 7; i ++)
    {
      temp = cells.getCell(i, 0).getValueType();
      cell = cells.getCell(i, 1);
      switch (temp)
      {
        case CellValueType.NULL:
          cell.setValue("Null");
          break;
        case CellValueType.BOOLEAN:
          cell.setValue("Boolean");
          break;
        case CellValueType.DATETIME:
          cell.setValue("Calendar");
          break;
        case CellValueType.STRING:
          cell.setValue("String");
          break;
        case CellValueType.INT:
          cell.setValue("Integer");
          break;
        case CellValueType.DOUBLE:
          cell.setValue("Double");
          break;
        case CellValueType.RICH_TEXT_STRING:
          cell.setValue("String");
          break;
      }
    }
  }
}
