package Data;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class NamedRangesServlet extends HttpServlet  {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
   throws IOException, ServletException
{
  OutputStream out = response.getOutputStream();
  try
  {
      setResponseHeader(response, "NamedRanges.xls");
      CreateNamedRanges(out);
   }
  catch (Exception ex)
  {
      ex.printStackTrace();

      // say sorry
      response.setContentType("text/html");
      PrintWriter writer = new PrintWriter(out);

      writer.println("<html>");
      writer.println("<head>");
      writer.println("<title>sorry</title>");
      writer.println("</head>");
      writer.println("<body>");
      writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
      ex.printStackTrace(writer);
      writer.println("</body>");
      writer.println("</html>");
      writer.close();
  }
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
       throws IOException, ServletException
 {
    doGet(request, response);
 }

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
   response.setContentType("application/vnd.ms-excel");
   response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateNamedRanges(OutputStream out) throws IOException
{
  Workbook workbook = new Workbook();

  CreateStaticReport(workbook);

  //Saving the Excel file
  workbook.save(out);
}

private void CreateStaticReport(Workbook workbook)
{
  Worksheets worksheets = workbook.getWorksheets();
  Worksheet worksheet = worksheets.getSheet(0);

  Cells cells = worksheet.getCells();
  Cell cell;

  //Create a named range and Set the name of the named range
 NamedRange nameRange = cells.createNamedRange("TestRange", "B1", "E5");
 //Accessing a specific Named Range
 NamedRange mynameRange = worksheets.getRangeByName("TestRange");
 cell = mynameRange.getCell(0,0);
 cell.setValue("First");

 //Accessing All Named Ranges in a Worksheet
 NamedRange[] nameRangeList = worksheets.getNamedRanges();
 NamedRange testNameRange ;
 for (int i = 0 ; i < nameRangeList.length ; i ++)
 {
   testNameRange = nameRangeList[i];
   cell = testNameRange.getCell(1, 0);
   cell.setValue("Second");
 }
 //Use cells.CreateRange method to extend it
 nameRange = cells.createNamedRange("TestRange", 0, 0, 6, 6);
 //access the address (row and column) of the range
 mynameRange = worksheets.getRangeByName("TestRange");
 int startRow = mynameRange.getStartRow();
 int endRow = mynameRange.getEndRow();
 int startColumn = mynameRange.getStartColumn();
 int endColumn = mynameRange.getEndColumn();
}
}
