package Formatting;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class BorderSettingServlet extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
   throws IOException, ServletException
{
  OutputStream out = response.getOutputStream();
  try
  {
      ServletContext sc = getServletContext();
      setResponseHeader(response, "BorderSetting.xls");
      CreateBorderSetting(out);
   }
  catch (Exception ex)
  {
      ex.printStackTrace();

      // say sorry
      response.setContentType("text/html");
      PrintWriter writer = new PrintWriter(out);

      writer.println("<html>");
      writer.println("<head>");
      writer.println("<title>sorry</title>");
      writer.println("</head>");
      writer.println("<body>");
      writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
      ex.printStackTrace(writer);
      writer.println("</body>");
      writer.println("</html>");
      writer.close();
  }
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
       throws IOException, ServletException
 {
    doGet(request, response);
 }

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
   response.setContentType("application/vnd.ms-excel");
   response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateBorderSetting(OutputStream out) throws IOException
{
  Workbook workbook = new Workbook();
  CreateStaticReport(workbook);

  //Saving the Excel file
  workbook.save(out);
}

private void CreateStaticReport(Workbook workbook)
{
  Worksheets worksheets = workbook.getWorksheets();
  Worksheet worksheet = worksheets.getSheet(0);

  Cells cells = worksheet.getCells();
  Cell cell;
  Style style;

  cell = cells.getCell("B2");
  style = cell.getStyle();

  //Set border color
  style.setBorderColor(BorderType.TOP,Color.BLUE);
  style.setBorderColor(BorderType.BOTTOM,Color.BLUE);
  style.setBorderColor(BorderType.LEFT,Color.BLUE);
  style.setBorderColor(BorderType.RIGHT,Color.BLUE);
  style.setBorderColor(BorderType.DIAGONAL_DOWN,Color.BLUE);
  style.setBorderColor(BorderType.DIAGONAL_UP,Color.BLUE);

  //Set the cell border type
  style.setBorderLine(BorderType.TOP,BorderLineType.DASHED);
  style.setBorderLine(BorderType.BOTTOM,BorderLineType.DASHED);
  style.setBorderLine(BorderType.LEFT,BorderLineType.DASHED);
  style.setBorderLine(BorderType.RIGHT,BorderLineType.DASHED);
  style.setBorderLine(BorderType.DIAGONAL_DOWN,BorderLineType.DASHED);
  style.setBorderLine(BorderType.DIAGONAL_UP,BorderLineType.DASHED);

  cell.setStyle(style);
}
}
