package Formatting;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class FontSettingServlet extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
   throws IOException, ServletException
{
  OutputStream out = response.getOutputStream();
  try
  {
      setResponseHeader(response, "FontSetting.xls");
      CreateFontSetting(out);
   }
  catch (Exception ex)
  {
      ex.printStackTrace();

      // say sorry
      response.setContentType("text/html");
      PrintWriter writer = new PrintWriter(out);

      writer.println("<html>");
      writer.println("<head>");
      writer.println("<title>sorry</title>");
      writer.println("</head>");
      writer.println("<body>");
      writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
      ex.printStackTrace(writer);
      writer.println("</body>");
      writer.println("</html>");
      writer.close();
  }
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
       throws IOException, ServletException
 {
    doGet(request, response);
 }

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
   response.setContentType("application/vnd.ms-excel");
   response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateFontSetting(OutputStream out) throws IOException
{
  Workbook workbook = new Workbook();

  CreateStaticReport(workbook);

  //Saving the Excel file
  workbook.save(out);
}

private void CreateStaticReport(Workbook workbook)
{
  Worksheets worksheets = workbook.getWorksheets();
  Worksheet worksheet = worksheets.getSheet(0);

  Cells cells = worksheet.getCells();
  Cell cell;
  Style style;

  //Set font to A2
  cell = cells.getCell("A2");
  cell.setValue("Aspose");
  style = cell.getStyle();
  Font font1 = new Font();
  font1.setColor(Color.RED);
  style.setFont(font1);
  cell.setStyle(style);

  //Set font to B2
  cell = cells.getCell("B2");
  cell.setValue("Aspose");
  style = cell.getStyle();
  Font font2 = new Font();
  font2.setBold(true);
  style.setFont(font2);
  cell.setStyle(style);

  //Set font to C2
  cell = cells.getCell("C2");
  cell.setValue("Aspose");
  style = cell.getStyle();
  Font font3 = new Font();
  font3.setItalic(true);
  style.setFont(font3);
  cell.setStyle(style);
}
}
