package Formatting;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class FormattingRangeServlet extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  throws IOException, ServletException
{
 OutputStream out = response.getOutputStream();
 try
 {
     setResponseHeader(response, "FormattingRange.xls");
     CreatePatternSetting(out);
  }
 catch (Exception ex)
 {
     ex.printStackTrace();

     // say sorry
     response.setContentType("text/html");
     PrintWriter writer = new PrintWriter(out);

     writer.println("<html>");
     writer.println("<head>");
     writer.println("<title>sorry</title>");
     writer.println("</head>");
     writer.println("<body>");
     writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
     ex.printStackTrace(writer);
     writer.println("</body>");
     writer.println("</html>");
     writer.close();
 }
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException
{
   doGet(request, response);
}

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
  response.setContentType("application/vnd.ms-excel");
  response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreatePatternSetting(OutputStream out) throws IOException
{
 Workbook workbook = new Workbook();
 CreateStaticReport(workbook);

 //Saving the Excel file
 workbook.save(out);
}

  private void CreateStaticReport(Workbook workbook)
  {
    Worksheets worksheets = workbook.getWorksheets();
    Worksheet worksheet = worksheets.getSheet(0);

    Cells cells = worksheet.getCells();
    Cell cell;
    Font font = new Font();
    Style style = workbook.createStyle();
    style.setVAlignment(TextAlignmentType.CENTER);
    style.setHAlignment(TextAlignmentType.CENTER);
    font.setColor(Color.GREEN);
    style.setShrinked(true);
    style.setBorderColor(BorderType.BOTTOM, Color.RED);
    style.setBorderLine(BorderType.BOTTOM, BorderLineType.DOTTED);

    //Access a row from the Rows collection
    Row row = cells.getRow(0);
    row.setStyle(style);

    //Access a column from the Columns collection
    Column column = cells.getColumns().getColumn(0);
    column.setStyle(style);
  }
}
