package Formatting;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class NumberFormattingServlet extends HttpServlet {

  private static final String TEMPLATE_FILE_PATH_PART = "/WEB-INF/Designer/Workbooks/NumberFormatting.xls";

  public void doGet(HttpServletRequest request, HttpServletResponse response)
   throws IOException, ServletException
{
  OutputStream out = response.getOutputStream();
  try
  {
      ServletContext sc = getServletContext();
      String template_file_path = sc.getRealPath(TEMPLATE_FILE_PATH_PART);

      setResponseHeader(response, "NumberFormatting.xls");
      CreateNumberFormatting(out, template_file_path);
   }
  catch (Exception ex)
  {
      ex.printStackTrace();

      // say sorry
      response.setContentType("text/html");
      PrintWriter writer = new PrintWriter(out);

      writer.println("<html>");
      writer.println("<head>");
      writer.println("<title>sorry</title>");
      writer.println("</head>");
      writer.println("<body>");
      writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
      ex.printStackTrace(writer);
      writer.println("</body>");
      writer.println("</html>");
      writer.close();
  }
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
       throws IOException, ServletException
 {
    doGet(request, response);
 }

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
   response.setContentType("application/vnd.ms-excel");
   response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateNumberFormatting(OutputStream out, String template_file_path) throws IOException
{
  Workbook workbook = new Workbook();

  workbook.open(template_file_path);

  CreateStaticReport(workbook);

  //Saving the Excel file
  workbook.save(out);
}

private void CreateStaticReport(Workbook workbook)
{
  Worksheets worksheets = workbook.getWorksheets();
  Worksheet  worksheet = worksheets.getSheet(0);

  Cell cell;
  Cells cells = worksheet.getCells();
  Style style ;
  int number = 0;
  String temp = "";
  Double d ;

  for (int i = 1; i <= 36; i ++)
  {
    cell = cells.getCell(i, 0);
    temp = cell.getStringValue();

    switch (cell.getValueType())
    {
      case 4://INT Type
        number = (Integer)cell.getValue();
        break;
      case 5://DOUBLE Type
        d = (Double)cell.getValue();
        number = d.intValue();
        break;
    }

    //Set the display format of numbers and dates
    cell = cells.getCell(i, 1);
    cell.setValue(123.5);
    style = cell.getStyle();
    style.setNumber(number);
    cell.setStyle(style);
  }
}
}
