package Other;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.aspose.cells.Picture;
import com.aspose.cells.Workbook;
import com.aspose.cells.Worksheet;
import com.aspose.cells.Worksheets;

public class AddingPictures extends HttpServlet  {

  private static final String TEMPLATE_Image_PATH_PART= "/Images/school.JPG";

  public void doGet(HttpServletRequest request, HttpServletResponse response)
throws IOException, ServletException
{
OutputStream out = response.getOutputStream();
try
{
  ServletContext sc = getServletContext();
  String template_image_path = sc.getRealPath(TEMPLATE_Image_PATH_PART);

   setResponseHeader(response, "AddingPictures.xls");
   CreateStaticReport(out, template_image_path);
}
catch (Exception ex)
{
   ex.printStackTrace();

   // say sorry
   response.setContentType("text/html");
   PrintWriter writer = new PrintWriter(out);

   writer.println("<html>");
   writer.println("<head>");
   writer.println("<title>sorry</title>");
   writer.println("</head>");
   writer.println("<body>");
   writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
   ex.printStackTrace(writer);
   writer.println("</body>");
   writer.println("</html>");
   writer.close();
}
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException
{
 doGet(request, response);
}

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
response.setContentType("application/vnd.ms-excel");
response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateStaticReport(OutputStream out, String template_image_path) throws IOException
{
Workbook workbook = new Workbook();

Worksheets worksheets = workbook.getWorksheets();
Worksheet worksheet = worksheets.getSheet(0);

  //Insert a picture into a cell
  Picture picture = worksheet.getShapes().addPicture(1, 1, template_image_path);

  //Insert a picture into a cell using a stream
  FileInputStream fis = new FileInputStream(template_image_path);
  fis.read();
  byte[] data = new byte[fis.available()];
  fis.read(data);

//Saving the Excel file
workbook.save(out);
}

}
