package PageSetup;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class SettingMargins extends HttpServlet  {

  private static final String TEMPLATE_FILE_PATH_PART = "/WEB-INF/Designer/book1.xls";

 public void doGet(HttpServletRequest request, HttpServletResponse response)
throws IOException, ServletException
{
OutputStream out = response.getOutputStream();
try
{
 ServletContext sc = getServletContext();
 String template_file_path = sc.getRealPath(TEMPLATE_FILE_PATH_PART);

 setResponseHeader(response, "SettingMargins.xls");
 CreateStaticReport(out, template_file_path);
}
catch (Exception ex)
{
 ex.printStackTrace();

 // say sorry
 response.setContentType("text/html");
 PrintWriter writer = new PrintWriter(out);

 writer.println("<html>");
 writer.println("<head>");
 writer.println("<title>sorry</title>");
 writer.println("</head>");
 writer.println("<body>");
 writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
 ex.printStackTrace(writer);
 writer.println("</body>");
 writer.println("</html>");
 writer.close();
}
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
  throws IOException, ServletException
{
doGet(request, response);
}

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
response.setContentType("application/vnd.ms-excel");
response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateStaticReport(OutputStream out, String template_file_path) throws IOException
{
Workbook workbook = new Workbook();

workbook.open(template_file_path);

Worksheets worksheets = workbook.getWorksheets();
Worksheet worksheet = worksheets.getSheet(0);

PageSetup pageSetup = worksheet.getPageSetup();
pageSetup.setBottomMargin(5);
pageSetup.setFooterMargin(5);
pageSetup.setHeaderMargin(5);
pageSetup.setLeftMargin(5);
pageSetup.setRightMargin(5);
pageSetup.setTopMargin(5);

//Saving the Excel file
workbook.save(out);
}

}
