package PivotTable;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class PivotTableServlet extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
     throws IOException, ServletException
  {
    OutputStream out = response.getOutputStream();
    try
    {
        setResponseHeader(response, "PivotTable.xls");
        CreatePivotTable(out);
     }
    catch (Exception ex)
    {
        ex.printStackTrace();

        // say sorry
        response.setContentType("text/html");
        PrintWriter writer = new PrintWriter(out);

        writer.println("<html>");
        writer.println("<head>");
        writer.println("<title>sorry</title>");
        writer.println("</head>");
        writer.println("<body>");
        writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
        ex.printStackTrace(writer);
        writer.println("</body>");
        writer.println("</html>");
        writer.close();
    }
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response)
         throws IOException, ServletException
   {
      doGet(request, response);
   }

  private void setResponseHeader(HttpServletResponse response, String resultXLS)
  {
     response.setContentType("application/vnd.ms-excel");
     response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
  }

  private void CreatePivotTable(OutputStream out) throws IOException
  {
     Workbook workbook = new Workbook();

     CreateStaticData(workbook);
     CreateStaticReport(workbook);

     //Saving the Excel file
     workbook.save(out);
  }

  private void CreateStaticData(Workbook workbook)
  {
    Worksheets worksheets = workbook.getWorksheets();
    Worksheet worksheet = worksheets.getSheet(0);

    Cells cells = worksheet.getCells();
    //Setting the value to the cells
    Cell cell = cells.getCell("A1");
    cell.setValue("Sport");
    cell = cells.getCell("B1");
    cell.setValue("Quarter");
    cell = cells.getCell("C1");
    cell.setValue("Sales");

    cell = cells.getCell("A2");
    cell.setValue("Golf");
    cell = cells.getCell("A3");
    cell.setValue("1Golf");
    cell = cells.getCell("A4");
    cell.setValue("Tennis");
    cell = cells.getCell("A5");
    cell.setValue("Tennis");
    cell = cells.getCell("A6");
    cell.setValue("Tennis");
    cell = cells.getCell("A7");
    cell.setValue("Tennis");
    cell = cells.getCell("A8");
    cell.setValue("Golf");

    cell = cells.getCell("B2");
    cell.setValue("Qtr3");
    cell = cells.getCell("B3");
    cell.setValue("Qtr4");
    cell = cells.getCell("B4");
    cell.setValue("Qtr3");
    cell = cells.getCell("B5");
    cell.setValue("Qtr4");
    cell = cells.getCell("B6");
    cell.setValue("Qtr3");
    cell = cells.getCell("B7");
    cell.setValue("Qtr4");
    cell = cells.getCell("B8");
    cell.setValue("Qtr3");

    cell = cells.getCell("C2");
    cell.setValue(1500);
    cell = cells.getCell("C3");
    cell.setValue(2000);
    cell = cells.getCell("C4");
    cell.setValue(600);
    cell = cells.getCell("C5");
    cell.setValue(1500);
    cell = cells.getCell("C6");
    cell.setValue(4070);
    cell = cells.getCell("C7");
    cell.setValue(5000);
    cell = cells.getCell("C8");
    cell.setValue(6430);
  }

  private void CreateStaticReport(Workbook workbook)
  {
    Worksheets worksheets = workbook.getWorksheets();
    Worksheet worksheet = worksheets.getSheet(0);

    PivotTables pivotTables = worksheet.getPivotTables();

    //Adding a PivotTable to the worksheet
    int index = pivotTables.add("=A1:C8","E3","PivotTable2");

    //Accessing the instance of the newly added PivotTable
    PivotTable pivotTable = pivotTables.get(index);

    //Unshowing grand totals for rows.
    pivotTable.setRowGrand(false);

    //Draging the first field to the row area.
    pivotTable.addFieldToArea(PivotFieldType.ROW,0);

    //Draging the second field to the column area.
    pivotTable.addFieldToArea(PivotFieldType.COLUMN,1);

    //Draging the third field to the data area.
    pivotTable.addFieldToArea(PivotFieldType.DATA,2);
  }
}
