package RowsAndColumns;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class AdjustingRowsAndColumns extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
 throws IOException, ServletException
{
OutputStream out = response.getOutputStream();
try
{
    String commandName = request.getParameter("_command");
    setResponseHeader(response, "AdjustingRowsAndColumns.xls");
    CreateReport(out);
 }
catch (Exception ex)
{
    ex.printStackTrace();

    // say sorry
    response.setContentType("text/html");
    PrintWriter writer = new PrintWriter(out);

    writer.println("<html>");
    writer.println("<head>");
    writer.println("<title>sorry</title>");
    writer.println("</head>");
    writer.println("<body>");
    writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
    ex.printStackTrace(writer);
    writer.println("</body>");
    writer.println("</html>");
    writer.close();
}
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
     throws IOException, ServletException
{
  doGet(request, response);
}

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
 response.setContentType("application/vnd.ms-excel");
 response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateReport(OutputStream out) throws IOException
{
   Workbook workbook = new Workbook();

   AdjustingRowsAndColumns(workbook);

   //Saving the Excel file
   workbook.save(out);
}

 private void AdjustingRowsAndColumns(Workbook workbook)
 {
   Worksheets worksheets = workbook.getWorksheets();
   Worksheet worksheet = worksheets.getSheet(0);

   Cells cells = worksheet.getCells();

   //Set the height of all row in the worksheet
   cells.setStandardHeight(20);
   //Set the width of all columns in the worksheet
   cells.setStandardWidth(20);

   //Set the width of the first column
   cells.setColumnWidth(0, 12);
   cells.setColumnWidth(1, 40);
   //Setting the height of row
   cells.setRowHeight(1, 8);
 }
}
