package RowsAndColumns;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class GroupingRowsAndColumns extends HttpServlet {

  private static final String TEMPLATE_FILE_PATH_PART1 = "/WEB-INF/Designer/Workbooks/GroupingRowsAndColumns.xls";
  private static final String TEMPLATE_FILE_PATH_PART2 = "/WEB-INF/Designer/Workbooks/UnGroupingRowsAndColumns.xls";

  public void doGet(HttpServletRequest request, HttpServletResponse response)
 throws IOException, ServletException
{
OutputStream out = response.getOutputStream();
try
{
    String commandName = request.getParameter("_command");
    ServletContext sc = getServletContext();
    String template_file_path = "";


    if (commandName.equals("Group"))
    {
      template_file_path = sc.getRealPath(TEMPLATE_FILE_PATH_PART1);
      setResponseHeader(response, "GroupingRowsAndColumns.xls");
    }
    else
    {
      template_file_path = sc.getRealPath(TEMPLATE_FILE_PATH_PART2);
      setResponseHeader(response, "UnGroupingRowsAndColumns.xls");
     }

    CreatePatternSetting(out, template_file_path, commandName);
 }
catch (Exception ex)
{
    ex.printStackTrace();

    // say sorry
    response.setContentType("text/html");
    PrintWriter writer = new PrintWriter(out);

    writer.println("<html>");
    writer.println("<head>");
    writer.println("<title>sorry</title>");
    writer.println("</head>");
    writer.println("<body>");
    writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
    ex.printStackTrace(writer);
    writer.println("</body>");
    writer.println("</html>");
    writer.close();
}
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
     throws IOException, ServletException
{
  doGet(request, response);
}

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
 response.setContentType("application/vnd.ms-excel");
 response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreatePatternSetting(OutputStream out, String template_file_path, String commandName) throws IOException
{
   Workbook workbook = new Workbook();

   //Open template
    workbook.open(template_file_path);

   Worksheets worksheets = workbook.getWorksheets();
   Worksheet worksheet = worksheets.getSheet(0);

   if (commandName.equals("Group"))
     GroupingRowsAndColumns(worksheet);
   else
     UnGroupingRowsAndColumns(worksheet);

   //Saving the Excel file
   workbook.save(out);
}

 private void GroupingRowsAndColumns(Worksheet worksheet)
 {
   Cells cells = worksheet.getCells();
   cells.groupRows(0, 9, false);
   cells.groupColumns(0, 1, false);

   //Set SummaryRowBelow property
   worksheet.getOutline().setSummaryRowBelow(true);
   //Set SummaryColumnRight property
   worksheet.getOutline().setSummaryColumnRight(true);
 }

 private void UnGroupingRowsAndColumns(Worksheet worksheet)
 {
   Cells cells = worksheet.getCells();
   cells.ungroupRows(0, 9);
   cells.ungroupRows(0, 1);
 }
}
