package RowsAndColumns;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class HidingRowsAndColumns extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
 throws IOException, ServletException
{
OutputStream out = response.getOutputStream();
try
{
    String commandName = request.getParameter("_command");
    setResponseHeader(response, "HidingRowsAndColumns.xls");
    CreatePatternSetting(out, commandName);
 }
catch (Exception ex)
{
    ex.printStackTrace();

    // say sorry
    response.setContentType("text/html");
    PrintWriter writer = new PrintWriter(out);

    writer.println("<html>");
    writer.println("<head>");
    writer.println("<title>sorry</title>");
    writer.println("</head>");
    writer.println("<body>");
    writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
    ex.printStackTrace(writer);
    writer.println("</body>");
    writer.println("</html>");
    writer.close();
}
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
     throws IOException, ServletException
{
  doGet(request, response);
}

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
 response.setContentType("application/vnd.ms-excel");
 response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreatePatternSetting(OutputStream out, String commandName) throws IOException
{
   Workbook workbook = new Workbook();

   Worksheets worksheets = workbook.getWorksheets();
   Worksheet worksheet = worksheets.getSheet(0);

   if (commandName.equals("Display"))
     DisplayingRowsAndColumns(worksheet);
   else
     HidingRowsAndColumns(worksheet);

   //Saving the Excel file
   workbook.save(out);
}

  private void DisplayingRowsAndColumns(Worksheet worksheet)
  {
    //Hide the 3rd row of the worksheet
    worksheet.getCells().unhideRow(2, 13.5);
    //Hide the 2nd column of the worksheet
    worksheet.getCells().unhideColumn(1, 15);
  }

  private void HidingRowsAndColumns(Worksheet worksheet)
  {
    //Hide the 3rd row of the worksheet
    worksheet.getCells().hideRow(2);

    //Hide the 2nd column of the worksheet
    worksheet.getCells().hideColumn(1);
  }
}
