package RowsAndColumns;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class InsertingAndDeletingRowsAndColumns extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  throws IOException, ServletException
{
 OutputStream out = response.getOutputStream();
 try
 {
     String commandName = request.getParameter("_command");
     setResponseHeader(response, "InsertingAndDeletingRowsAndColumns.xls");
     CreatePatternSetting(out, commandName);
  }
 catch (Exception ex)
 {
     ex.printStackTrace();

     // say sorry
     response.setContentType("text/html");
     PrintWriter writer = new PrintWriter(out);

     writer.println("<html>");
     writer.println("<head>");
     writer.println("<title>sorry</title>");
     writer.println("</head>");
     writer.println("<body>");
     writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
     ex.printStackTrace(writer);
     writer.println("</body>");
     writer.println("</html>");
     writer.close();
 }
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException
{
   doGet(request, response);
}

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
  response.setContentType("application/vnd.ms-excel");
  response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreatePatternSetting(OutputStream out, String commandName) throws IOException
{
 Workbook workbook = new Workbook();
 if (commandName.equals("Insert"))
   InsertRowsAndColumns(workbook);
 else
   DeleteRowsAndColumns(workbook);

 //Saving the Excel file
 workbook.save(out);
}

  private void InsertRowsAndColumns(Workbook workbook)
  {
    Worksheets worksheets = workbook.getWorksheets();
    Worksheet worksheet = worksheets.getSheet(0);

    Cells cells = worksheet.getCells();

    CreateStaticReport(cells);

    //Insert a row or column into the worksheet
    cells.insertRows(2, 10);
    cells.insertColumns(1, 1);
  }

  private void DeleteRowsAndColumns(Workbook workbook)
  {
    Worksheets worksheets = workbook.getWorksheets();
    Worksheet worksheet = worksheets.getSheet(0);

    Cells cells = worksheet.getCells();

    CreateStaticReport(cells);

    //Delete a row or column into the worksheet
    cells.deleteRows(2, 2, false);
    cells.deleteColumns(1, 1, false);
  }

  private void CreateStaticReport(Cells cells)
  {
    Cell cell;

   //Put a value into a cell
   cell = cells.getCell("A1");
   cell.setValue("Aspose");
   cell = cells.getCell("A2");
   cell.setValue(123);
   cell = cells.getCell("A3");
   cell.setValue("Hello World");
   cell = cells.getCell("B1");
   cell.setValue(120);
  }
}
