package Security;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import com.aspose.cells.*;
import com.aspose.cells.Chart;

public class AdvancedProtection extends HttpServlet{

  private static final String TEMPLATE_FILE_PATH_PART = "/WEB-INF/Designer/book1.xls";

  public void doGet(HttpServletRequest request, HttpServletResponse response)
throws IOException, ServletException
{
OutputStream out = response.getOutputStream();
try
{
  ServletContext sc = getServletContext();
  String template_file_path = sc.getRealPath(TEMPLATE_FILE_PATH_PART);

  setResponseHeader(response, "AdvancedProtection.xls");
  CreateStaticReport(out, template_file_path);
}
catch (Exception ex)
{
  ex.printStackTrace();

  // say sorry
  response.setContentType("text/html");
  PrintWriter writer = new PrintWriter(out);

  writer.println("<html>");
  writer.println("<head>");
  writer.println("<title>sorry</title>");
  writer.println("</head>");
  writer.println("<body>");
  writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
  ex.printStackTrace(writer);
  writer.println("</body>");
  writer.println("</html>");
  writer.close();
}
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
   throws IOException, ServletException
{
doGet(request, response);
}

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
response.setContentType("application/vnd.ms-excel");
response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateStaticReport(OutputStream out, String template_file_path) throws IOException
{
 Workbook workbook = new Workbook();

 workbook.open(template_file_path);

 Worksheets worksheets = workbook.getWorksheets();
 Worksheet worksheet = worksheets.getSheet(0);

  Protection protection = new Protection();

  //Restricting users to delete columns of the worksheet
  protection.setDeletingColumnsAllowed(false);

  //Restricting users to delete row of the worksheet
  protection.setDeletingRowsAllowed (false);

  //Allowing users to edit contents of the worksheet
  protection.setEditingContentsAllowed (false);

  //Allowing users to edit objects of the worksheet
 protection.setEditingObjectsAllowed (true);

 //Allowing users to edit scenarios of the worksheet
 protection.setEditingScenariosAllowed (true);

 //Restricting users to filter
 protection.setFilteringAllowed (false);

 //Allowing users to format cells of the worksheet
 protection.setFormattingCellsAllowed (true);

 //Allowing users to format rows of the worksheet
 protection.setFormattingRowsAllowed (true);

 //Allowing users to insert columns in the worksheet
 protection.setInsertingColumnsAllowed (true);

 //Allowing users to insert hyperlinks in the worksheet
 protection.setInsertingHyperlinksAllowed (true);

 //Allowing users to insert rows in the worksheet
 protection.setInsertingRowsAllowed(true);

 //Allowing users to select locked cells of the worksheet
 protection.setSelectingLockedCellsAllowed(true);

 //Allowing users to select unlocked cells of the worksheet
 protection.setSelectingUnlockedCellsAllowed(true);
 //Allowing users to sort
 protection.setSortingAllowed(true);

 //Allowing users to use pivot tables in the worksheet
 protection.setUsingPivotTablesAllowed (true);

 worksheet.protect(protection);

//Saving the Excel file
workbook.save(out);
}
}
