import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.aspose.cells.*;

public class SmartMarkerServlet extends HttpServlet
{
   /**
    * 
    */
   private static final long serialVersionUID = 3257562897738708533L;

   private static final String DB_URL_P1 = "jdbc:odbc:driver={Microsoft Access Driver (*.mdb)};DBQ=";

   private static final String DB_URL_P2 = "/WEB-INF/Database/Northwind.mdb";

   private static final String TEMPLATE_FILE_PATH_PART = "/WEB-INF/Designer/SmartMarkerDesigner.xls";

   private void setResponseHeader(HttpServletResponse response, String resultXLS)
   {
      response.setContentType("application/vnd.ms-excel");
      response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
   }
   
   public void doGet(HttpServletRequest request, HttpServletResponse response)
         throws IOException, ServletException
   {
      OutputStream out = response.getOutputStream();
      try {
         String command = request.getParameter("_command");

         ServletContext sc = getServletContext();
         String db_url = DB_URL_P1 + sc.getRealPath(DB_URL_P2);
         String template_file_path = sc.getRealPath(TEMPLATE_FILE_PATH_PART);
         Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
         if(command.equals("SmartDesigner")) {
            setResponseHeader(response, "SmartMarkerDesigner.xls");
            CreateSmartView(out, db_url, template_file_path);
         }else if(command.equals("SmartResult")) {
            setResponseHeader(response, "SmartMarker.xls");
            CreateSmart(out, db_url, template_file_path);
         }
      } catch (Exception x) {

//       say sorry
         response.setContentType("text/html");
         PrintWriter writer = new PrintWriter(out);
         
         writer.println("<html>");
         writer.println("<head>");
         writer.println("<title>sorry</title>");
         writer.println("</head>");
         writer.println("<body>");
         writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
         x.printStackTrace(writer);
         writer.println("</body>");
         writer.println("</html>");
         writer.close();
      }
   }
   
   public void doPost(HttpServletRequest request, HttpServletResponse response)
         throws IOException, ServletException
   {
      doGet(request, response);
   }
   
   private static void CreateSmartView(OutputStream out, String db_url,
         String template_file_path) throws IOException, SQLException
   {
      FileInputStream fileInputStream = new FileInputStream(template_file_path);
      byte[] buffer = new byte[fileInputStream.available()];
      fileInputStream.read(buffer,0,buffer.length);
      out.write(buffer);
   }
   
   private static void CreateSmart(OutputStream out, String db_url,
         String template_file_path) throws IOException, SQLException
   {
      WorkbookDesigner designer = new WorkbookDesigner();
      designer.open(template_file_path);
      designer.setDataSource("Variable", "Single Variable");
      designer.setDataSource("MultiVariable", new String[]{"Variable 1", "Variable 2", "Variable 3"});
      designer.setDataSource("MultiVariable2", new String[]{"Skip 1", "Skip 2", "Skip 3"});
      designer.setDataSource("Array1Dim", new String[]{"A1", "A2", "A3"});
      designer.setDataSource("Array2Dim", new String[][]{{"A11", "A12", "A13"},{"A21", "A22", "A23", "A24"},{"A31", "A32", },});
      Connection conn = null;
      Statement stmt = null;
      ResultSet rs = null;
      try{
         conn = DriverManager.getConnection(db_url);
         stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_READ_ONLY);
         rs = stmt.executeQuery(
               "SELECT Address, City, CompanyName, ContactName, ContactTitle, Country, CustomerID, Fax, Phone, PostalCode, Region" + 
               " FROM Customers");
         designer.setDataSource("Customers",rs);

         conn = DriverManager.getConnection(db_url);
         stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_READ_ONLY);
         ResultSet rs_order = stmt.executeQuery(
               "SELECT DISTINCTROW Invoices.* FROM Invoices");
         designer.setDataSource("Order Details",rs_order);
         AsposeDataTable dataTable = new DataTable();
         designer.setDataSource("Employee",dataTable);
         Person person = new Person("0","Aspose");
         designer.setDataSource("Person",person);
      }catch(java.sql.SQLException sqlEx){
         sqlEx.printStackTrace();
      }catch(Exception e){
         e.printStackTrace();
      }
      designer.process(false);
      designer.save(out);
     
      try{
         if (stmt != null) {
            stmt.close();
         }
         if (conn != null) {
            conn.close();
         }
      }catch(SQLException sqlEx){
         
      }
      

   }
}
