package Worksheets;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.aspose.cells.Workbook;
import com.aspose.cells.Worksheet;
import com.aspose.cells.Worksheets;

public class ManagingWorksheets extends HttpServlet {

  private static final String TEMPLATE_FILE_PATH_PART = "/WEB-INF/Designer/Workbooks/ManagingWorksheets.xls";

  public void doGet(HttpServletRequest request, HttpServletResponse response)
   throws IOException, ServletException
{
  OutputStream out = response.getOutputStream();
  try
  {
     ServletContext sc = getServletContext();
     String template_file_path = sc.getRealPath(TEMPLATE_FILE_PATH_PART);

      String commandName = request.getParameter("_command");
      setResponseHeader(response, "ManagingWorksheets.xls");
      CreateStaticReport(out, commandName, template_file_path);
   }
  catch (Exception ex)
  {
      ex.printStackTrace();

      // say sorry
      response.setContentType("text/html");
      PrintWriter writer = new PrintWriter(out);

      writer.println("<html>");
      writer.println("<head>");
      writer.println("<title>sorry</title>");
      writer.println("</head>");
      writer.println("<body>");
      writer.println("<h1>Sorry, the demo programme failed for some reason.</h1>");
      ex.printStackTrace(writer);
      writer.println("</body>");
      writer.println("</html>");
      writer.close();
  }
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
       throws IOException, ServletException
 {
    doGet(request, response);
 }

private void setResponseHeader(HttpServletResponse response, String resultXLS)
{
   response.setContentType("application/vnd.ms-excel");
   response.addHeader("content-disposition", "inline;  filename=" + resultXLS);
}

private void CreateStaticReport(OutputStream out, String commandName, String template_file_path) throws IOException
{
  Workbook workbook = new Workbook();

  if (commandName.equals("Add"))
    AddWorksheets(workbook);
  else
  {
    //Open template
    workbook.open(template_file_path);
    RemoveWorksheets(workbook);
  }
  //Saving the Excel file
  workbook.save(out);
}

private void AddWorksheets(Workbook workbook)
{
  Worksheets worksheets = workbook.getWorksheets();
  Worksheet worksheet = worksheets.getSheet(0);
  //Set the name of worksheet
  worksheet.setName("My Worksheet1");

  worksheets.addSheet();
  worksheet = worksheets.getSheet(1);
  //Set the name of worksheet
  worksheet.setName("My Worksheet2");

  worksheets.addSheet();
  worksheet = worksheets.getSheet(2);
  //Set the name of worksheet
  worksheet.setName("My Worksheet3");
}

  private void RemoveWorksheets(Workbook workbook)
  {
    Worksheets worksheets = workbook.getWorksheets();
    //Remove the worksheet
    worksheets.removeSheet(1);
  }
}
